! $Id: omegalib.nw,v 1.118.4.2 2006/05/15 08:39:27 ohl Exp $
!
! Copyright (C) 2000-2002 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
! and others
!
! O'Mega is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! O'Mega is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



































module omega_bispinor_colors
  use omega_kinds
  use omega_bispinors
  use omega_vectors
  use omega_bispinor_couplings
  use omega_couplings
  implicit none
  private
  public :: pr_phi_c
  public :: pr_unitarity_c
  public :: pr_feynman_c
  public :: pr_gauge_c
  public :: pr_rxi_c
  public :: pr_psi_c
  public :: v_ff_c_cc
  public :: v_ff_c_sc
  public :: v_ff_c_cs
  public :: v_ff_s_cc
  public :: a_ff_c_cc
  public :: a_ff_c_sc
  public :: a_ff_c_cs
  public :: a_ff_s_cc
  public :: vl_ff_c_cc
  public :: vl_ff_c_sc
  public :: vl_ff_c_cs
  public :: vl_ff_s_cc
  public :: vr_ff_c_cc
  public :: vr_ff_c_sc
  public :: vr_ff_c_cs
  public :: vr_ff_s_cc
  public :: vlr_ff_c_cc
  public :: vlr_ff_c_sc
  public :: vlr_ff_c_cs
  public :: vlr_ff_s_cc
  public :: va_ff_c_cc
  public :: va_ff_c_sc
  public :: va_ff_c_cs
  public :: va_ff_s_cc
  public :: f_vf_c_cc
  public :: f_vf_c_sc
  public :: f_vf_c_cs
  public :: f_vf_s_cc
  public :: f_af_c_cc
  public :: f_af_c_sc
  public :: f_af_c_cs
  public :: f_af_s_cc
  public :: f_vlf_c_cc
  public :: f_vlf_c_sc
  public :: f_vlf_c_cs
  public :: f_vlf_s_cc
  public :: f_vrf_c_cc
  public :: f_vrf_c_sc
  public :: f_vrf_c_cs
  public :: f_vrf_s_cc
  public :: f_vlrf_c_cc
  public :: f_vlrf_c_sc
  public :: f_vlrf_c_cs
  public :: f_vlrf_s_cc
  public :: f_vaf_c_cc
  public :: f_vaf_c_sc
  public :: f_vaf_c_cs
  public :: f_vaf_s_cc
  public :: s_ff_c_cc
  public :: s_ff_c_sc
  public :: s_ff_c_cs
  public :: s_ff_s_cc
  public :: p_ff_c_cc
  public :: p_ff_c_sc
  public :: p_ff_c_cs
  public :: p_ff_s_cc
  public :: sl_ff_c_cc
  public :: sl_ff_c_sc
  public :: sl_ff_c_cs
  public :: sl_ff_s_cc
  public :: sr_ff_c_cc
  public :: sr_ff_c_sc
  public :: sr_ff_c_cs
  public :: sr_ff_s_cc
  public :: slr_ff_c_cc
  public :: slr_ff_c_sc
  public :: slr_ff_c_cs
  public :: slr_ff_s_cc
  public :: sp_ff_c_cc
  public :: sp_ff_c_sc
  public :: sp_ff_c_cs
  public :: sp_ff_s_cc
  public :: f_sf_c_cc
  public :: f_sf_c_sc
  public :: f_sf_c_cs
  public :: f_sf_s_cc
  public :: f_pf_c_cc
  public :: f_pf_c_sc
  public :: f_pf_c_cs
  public :: f_pf_s_cc
  public :: f_slf_c_cc
  public :: f_slf_c_sc
  public :: f_slf_c_cs
  public :: f_slf_s_cc
  public :: f_srf_c_cc
  public :: f_srf_c_sc
  public :: f_srf_c_cs
  public :: f_srf_s_cc
  public :: f_slrf_c_cc
  public :: f_slrf_c_sc
  public :: f_slrf_c_cs
  public :: f_slrf_s_cc
  public :: f_spf_c_cc
  public :: f_spf_c_sc
  public :: f_spf_c_cs
  public :: f_spf_s_cc

contains
  pure function pr_phi_c (p, m, w, iwf) result (owf)
    complex(kind=omega_prec), dimension(:), intent(in) :: iwf
    complex(kind=omega_prec), dimension(lbound(iwf,dim=1):ubound(iwf,dim=1)) :: owf
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w
    integer :: i
    do i = lbound(iwf,dim=1), ubound(iwf,dim=1)
      owf(i) = pr_phi (p, m, w, iwf(i))
    end do
  end function pr_phi_c
  pure function pr_unitarity_c (p, m, w, iwf) result (owf)
    type(vector), dimension(:), intent(in) :: iwf
    type(vector), dimension(lbound(iwf,dim=1):ubound(iwf,dim=1)) :: owf
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w
    integer :: i
    do i = lbound(iwf,dim=1), ubound(iwf,dim=1)
      owf(i) = pr_unitarity (p, m, w, iwf(i))
    end do
  end function pr_unitarity_c
  pure function pr_feynman_c (p, iwf) result (owf)
    type(vector), dimension(:), intent(in) :: iwf
    type(vector), dimension(lbound(iwf,dim=1):ubound(iwf,dim=1)) :: owf
    type(momentum), intent(in) :: p
    integer :: i
    do i = lbound(iwf,dim=1), ubound(iwf,dim=1)
      owf(i) = pr_feynman (p, iwf(i))
    end do
  end function pr_feynman_c
  pure function pr_gauge_c (p, xi, iwf) result (owf)
    type(vector), dimension(:), intent(in) :: iwf
    type(vector), dimension(lbound(iwf,dim=1):ubound(iwf,dim=1)) :: owf
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: xi
    integer :: i
    do i = lbound(iwf,dim=1), ubound(iwf,dim=1)
      owf(i) = pr_gauge (p, xi, iwf(i))
    end do
  end function pr_gauge_c
  pure function pr_rxi_c (p, m, w, xi, iwf) result (owf)
    type(vector), dimension(:), intent(in) :: iwf
    type(vector), dimension(lbound(iwf,dim=1):ubound(iwf,dim=1)) :: owf
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w, xi
    integer :: i
    do i = lbound(iwf,dim=1), ubound(iwf,dim=1)
      owf(i) = pr_rxi (p, m, w, xi, iwf(i))
    end do
  end function pr_rxi_c
  pure function pr_psi_c (p, m, w, iwf) result (owf)
    type(bispinor), dimension(:), intent(in) :: iwf
    type(bispinor), dimension(lbound(iwf,dim=1):ubound(iwf,dim=1)) :: owf
    type(momentum), intent(in) :: p
    real(kind=omega_prec), intent(in) :: m, w
    integer :: i
    do i = lbound(iwf,dim=1), ubound(iwf,dim=1)
      owf(i) = pr_psi (p, m, w, iwf(i))
    end do
  end function pr_psi_c
  pure function v_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * v_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * v_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * v_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function v_ff_c_cc
  pure function v_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * v_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * v_ff (g, wf1, wf2(i2))
      end do
    end do
  end function v_ff_c_sc
  pure function v_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * v_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * v_ff (g, wf1(i1), wf2)
      end do
    end do
  end function v_ff_c_cs
  pure function v_ff_s_cc (c, g, wf1, wf2) result (wf)
    type(vector) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * v_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * v_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * v_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function v_ff_s_cc
  pure function a_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * a_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * a_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * a_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function a_ff_c_cc
  pure function a_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * a_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * a_ff (g, wf1, wf2(i2))
      end do
    end do
  end function a_ff_c_sc
  pure function a_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * a_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * a_ff (g, wf1(i1), wf2)
      end do
    end do
  end function a_ff_c_cs
  pure function a_ff_s_cc (c, g, wf1, wf2) result (wf)
    type(vector) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * a_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * a_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * a_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function a_ff_s_cc
  pure function vl_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * vl_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * vl_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * vl_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function vl_ff_c_cc
  pure function vl_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * vl_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * vl_ff (g, wf1, wf2(i2))
      end do
    end do
  end function vl_ff_c_sc
  pure function vl_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * vl_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * vl_ff (g, wf1(i1), wf2)
      end do
    end do
  end function vl_ff_c_cs
  pure function vl_ff_s_cc (c, g, wf1, wf2) result (wf)
    type(vector) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * vl_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * vl_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * vl_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function vl_ff_s_cc
  pure function vr_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * vr_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * vr_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * vr_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function vr_ff_c_cc
  pure function vr_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * vr_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * vr_ff (g, wf1, wf2(i2))
      end do
    end do
  end function vr_ff_c_sc
  pure function vr_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * vr_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * vr_ff (g, wf1(i1), wf2)
      end do
    end do
  end function vr_ff_c_cs
  pure function vr_ff_s_cc (c, g, wf1, wf2) result (wf)
    type(vector) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * vr_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * vr_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * vr_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function vr_ff_s_cc
  pure function vlr_ff_c_cc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * vlr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * vlr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * vlr_ff (gl, gr, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function vlr_ff_c_cc
  pure function vlr_ff_c_sc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * vlr_ff (gl, gr, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * vlr_ff (gl, gr, wf1, wf2(i2))
      end do
    end do
  end function vlr_ff_c_sc
  pure function vlr_ff_c_cs (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * vlr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * vlr_ff (gl, gr, wf1(i1), wf2)
      end do
    end do
  end function vlr_ff_c_cs
  pure function vlr_ff_s_cc (c, gl, gr, wf1, wf2) result (wf)
    type(vector) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * vlr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * vlr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * vlr_ff (gl, gr, wf1(i1), wf2(i2))
      end do
    end do
  end function vlr_ff_s_cc
  pure function va_ff_c_cc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * va_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * va_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * va_ff (gv, ga, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function va_ff_c_cc
  pure function va_ff_c_sc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * va_ff (gv, ga, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * va_ff (gv, ga, wf1, wf2(i2))
      end do
    end do
  end function va_ff_c_sc
  pure function va_ff_c_cs (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(vector), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * va_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * va_ff (gv, ga, wf1(i1), wf2)
      end do
    end do
  end function va_ff_c_cs
  pure function va_ff_s_cc (c, gv, ga, wf1, wf2) result (wf)
    type(vector) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * va_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * va_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * va_ff (gv, ga, wf1(i1), wf2(i2))
      end do
    end do
  end function va_ff_s_cc
  pure function f_vf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_vf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_vf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_vf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_vf_c_cc
  pure function f_vf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_vf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_vf (g, wf1, wf2(i2))
      end do
    end do
  end function f_vf_c_sc
  pure function f_vf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_vf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_vf (g, wf1(i1), wf2)
      end do
    end do
  end function f_vf_c_cs
  pure function f_vf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_vf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_vf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_vf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_vf_s_cc
  pure function f_af_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_af (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_af (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_af (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_af_c_cc
  pure function f_af_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_af (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_af (g, wf1, wf2(i2))
      end do
    end do
  end function f_af_c_sc
  pure function f_af_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_af (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_af (g, wf1(i1), wf2)
      end do
    end do
  end function f_af_c_cs
  pure function f_af_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_af (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_af (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_af (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_af_s_cc
  pure function f_vlf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_vlf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_vlf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_vlf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_vlf_c_cc
  pure function f_vlf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_vlf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_vlf (g, wf1, wf2(i2))
      end do
    end do
  end function f_vlf_c_sc
  pure function f_vlf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_vlf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_vlf (g, wf1(i1), wf2)
      end do
    end do
  end function f_vlf_c_cs
  pure function f_vlf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_vlf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_vlf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_vlf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_vlf_s_cc
  pure function f_vrf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_vrf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_vrf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_vrf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_vrf_c_cc
  pure function f_vrf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_vrf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_vrf (g, wf1, wf2(i2))
      end do
    end do
  end function f_vrf_c_sc
  pure function f_vrf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_vrf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_vrf (g, wf1(i1), wf2)
      end do
    end do
  end function f_vrf_c_cs
  pure function f_vrf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_vrf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_vrf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_vrf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_vrf_s_cc
  pure function f_vlrf_c_cc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_vlrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_vlrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_vlrf (gl, gr, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_vlrf_c_cc
  pure function f_vlrf_c_sc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(vector), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_vlrf (gl, gr, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_vlrf (gl, gr, wf1, wf2(i2))
      end do
    end do
  end function f_vlrf_c_sc
  pure function f_vlrf_c_cs (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_vlrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_vlrf (gl, gr, wf1(i1), wf2)
      end do
    end do
  end function f_vlrf_c_cs
  pure function f_vlrf_s_cc (c, gl, gr, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_vlrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_vlrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_vlrf (gl, gr, wf1(i1), wf2(i2))
      end do
    end do
  end function f_vlrf_s_cc
  pure function f_vaf_c_cc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_vaf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_vaf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_vaf (gv, ga, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_vaf_c_cc
  pure function f_vaf_c_sc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(vector), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_vaf (gv, ga, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_vaf (gv, ga, wf1, wf2(i2))
      end do
    end do
  end function f_vaf_c_sc
  pure function f_vaf_c_cs (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_vaf (gv, ga, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_vaf (gv, ga, wf1(i1), wf2)
      end do
    end do
  end function f_vaf_c_cs
  pure function f_vaf_s_cc (c, gv, ga, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(vector), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_vaf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_vaf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_vaf (gv, ga, wf1(i1), wf2(i2))
      end do
    end do
  end function f_vaf_s_cc
  pure function s_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * s_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * s_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * s_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function s_ff_c_cc
  pure function s_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * s_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * s_ff (g, wf1, wf2(i2))
      end do
    end do
  end function s_ff_c_sc
  pure function s_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * s_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * s_ff (g, wf1(i1), wf2)
      end do
    end do
  end function s_ff_c_cs
  pure function s_ff_s_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * s_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * s_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * s_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function s_ff_s_cc
  pure function p_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * p_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * p_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * p_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function p_ff_c_cc
  pure function p_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * p_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * p_ff (g, wf1, wf2(i2))
      end do
    end do
  end function p_ff_c_sc
  pure function p_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * p_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * p_ff (g, wf1(i1), wf2)
      end do
    end do
  end function p_ff_c_cs
  pure function p_ff_s_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * p_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * p_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * p_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function p_ff_s_cc
  pure function sl_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * sl_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * sl_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * sl_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function sl_ff_c_cc
  pure function sl_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * sl_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * sl_ff (g, wf1, wf2(i2))
      end do
    end do
  end function sl_ff_c_sc
  pure function sl_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * sl_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * sl_ff (g, wf1(i1), wf2)
      end do
    end do
  end function sl_ff_c_cs
  pure function sl_ff_s_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * sl_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * sl_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * sl_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function sl_ff_s_cc
  pure function sr_ff_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * sr_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * sr_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * sr_ff (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function sr_ff_c_cc
  pure function sr_ff_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * sr_ff (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * sr_ff (g, wf1, wf2(i2))
      end do
    end do
  end function sr_ff_c_sc
  pure function sr_ff_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * sr_ff (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * sr_ff (g, wf1(i1), wf2)
      end do
    end do
  end function sr_ff_c_cs
  pure function sr_ff_s_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * sr_ff (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * sr_ff (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * sr_ff (g, wf1(i1), wf2(i2))
      end do
    end do
  end function sr_ff_s_cc
  pure function slr_ff_c_cc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * slr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * slr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * slr_ff (gl, gr, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function slr_ff_c_cc
  pure function slr_ff_c_sc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * slr_ff (gl, gr, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * slr_ff (gl, gr, wf1, wf2(i2))
      end do
    end do
  end function slr_ff_c_sc
  pure function slr_ff_c_cs (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * slr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * slr_ff (gl, gr, wf1(i1), wf2)
      end do
    end do
  end function slr_ff_c_cs
  pure function slr_ff_s_cc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gl, gr
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * slr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * slr_ff (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * slr_ff (gl, gr, wf1(i1), wf2(i2))
      end do
    end do
  end function slr_ff_s_cc
  pure function sp_ff_c_cc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * sp_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * sp_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * sp_ff (gv, ga, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function sp_ff_c_cc
  pure function sp_ff_c_sc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * sp_ff (gv, ga, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * sp_ff (gv, ga, wf1, wf2(i2))
      end do
    end do
  end function sp_ff_c_sc
  pure function sp_ff_c_cs (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * sp_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * sp_ff (gv, ga, wf1(i1), wf2)
      end do
    end do
  end function sp_ff_c_cs
  pure function sp_ff_s_cc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gv, ga
    type(bispinor), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * sp_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * sp_ff (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * sp_ff (gv, ga, wf1(i1), wf2(i2))
      end do
    end do
  end function sp_ff_s_cc
  pure function f_sf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_sf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_sf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_sf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_sf_c_cc
  pure function f_sf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_sf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_sf (g, wf1, wf2(i2))
      end do
    end do
  end function f_sf_c_sc
  pure function f_sf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_sf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_sf (g, wf1(i1), wf2)
      end do
    end do
  end function f_sf_c_cs
  pure function f_sf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_sf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_sf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_sf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_sf_s_cc
  pure function f_pf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_pf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_pf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_pf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_pf_c_cc
  pure function f_pf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_pf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_pf (g, wf1, wf2(i2))
      end do
    end do
  end function f_pf_c_sc
  pure function f_pf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_pf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_pf (g, wf1(i1), wf2)
      end do
    end do
  end function f_pf_c_cs
  pure function f_pf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_pf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_pf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_pf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_pf_s_cc
  pure function f_slf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_slf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_slf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_slf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_slf_c_cc
  pure function f_slf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_slf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_slf (g, wf1, wf2(i2))
      end do
    end do
  end function f_slf_c_sc
  pure function f_slf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_slf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_slf (g, wf1(i1), wf2)
      end do
    end do
  end function f_slf_c_cs
  pure function f_slf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_slf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_slf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_slf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_slf_s_cc
  pure function f_srf_c_cc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_srf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_srf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_srf (g, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_srf_c_cc
  pure function f_srf_c_sc (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_srf (g, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_srf (g, wf1, wf2(i2))
      end do
    end do
  end function f_srf_c_sc
  pure function f_srf_c_cs (c, g, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_srf (g, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_srf (g, wf1(i1), wf2)
      end do
    end do
  end function f_srf_c_cs
  pure function f_srf_s_cc (c, g, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: g
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_srf (g, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_srf (g, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_srf (g, wf1(i1), wf2(i2))
      end do
    end do
  end function f_srf_s_cc
  pure function f_slrf_c_cc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_slrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_slrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_slrf (gl, gr, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_slrf_c_cc
  pure function f_slrf_c_sc (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    complex(kind=omega_prec), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_slrf (gl, gr, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_slrf (gl, gr, wf1, wf2(i2))
      end do
    end do
  end function f_slrf_c_sc
  pure function f_slrf_c_cs (c, gl, gr, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gl, gr
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_slrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_slrf (gl, gr, wf1(i1), wf2)
      end do
    end do
  end function f_slrf_c_cs
  pure function f_slrf_s_cc (c, gl, gr, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gl, gr
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_slrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_slrf (gl, gr, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_slrf (gl, gr, wf1(i1), wf2(i2))
      end do
    end do
  end function f_slrf_s_cc
  pure function f_spf_c_cc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i1, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1),lbound(wf2,dim=1)) &
                * f_spf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,lbound(wf1,dim=1),i2) &
                 * f_spf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
      end do
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
          wf(i) = wf(i) + c(i,i1,i2) * f_spf (gv, ga, wf1(i1), wf2(i2))
        end do
      end do
    end do
  end function f_spf_c_cc
  pure function f_spf_c_sc (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    complex(kind=omega_prec), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i, i2
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf2,dim=1)) * f_spf (gv, ga, wf1, wf2(lbound(wf2,dim=1)))
      do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
        wf(i) = wf(i) + c(i,i2) * f_spf (gv, ga, wf1, wf2(i2))
      end do
    end do
  end function f_spf_c_sc
  pure function f_spf_c_cs (c, gv, ga, wf1, wf2) result (wf)
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    type(bispinor), dimension(lbound(c,dim=1):ubound(c,dim=1)) :: wf
    complex(kind=omega_prec), intent(in) :: gv, ga
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), intent(in) :: wf2
    integer :: i, i1
    do i = lbound(wf,dim=1), ubound(wf,dim=1)
      wf(i) = c(i,lbound(wf1,dim=1)) * f_spf (gv, ga, wf1(lbound(wf1,dim=1)), wf2)
      do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
        wf(i) = wf(i) + c(i,i1) * f_spf (gv, ga, wf1(i1), wf2)
      end do
    end do
  end function f_spf_c_cs
  pure function f_spf_s_cc (c, gv, ga, wf1, wf2) result (wf)
    type(bispinor) :: wf
    complex(kind=omega_prec), dimension(:,:), intent(in) :: c
    complex(kind=omega_prec), intent(in) :: gv, ga
    complex(kind=omega_prec), dimension(:), intent(in) :: wf1
    type(bispinor), dimension(:), intent(in) :: wf2
    integer :: i1, i2
    wf = c(lbound(wf1,dim=1),lbound(wf2,dim=1)) &
           * f_spf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(lbound(wf2,dim=1)))
    do i2 = lbound(wf2,dim=1) + 1, ubound(wf2,dim=1)
      wf = wf + c(lbound(wf1,dim=1),i2) * f_spf (gv, ga, wf1(lbound(wf1,dim=1)), wf2(i2))
    end do
    do i1 = lbound(wf1,dim=1) + 1, ubound(wf1,dim=1)
      do i2 = lbound(wf2,dim=1), ubound(wf2,dim=1)
        wf = wf + c(i1,i2) * f_spf (gv, ga, wf1(i1), wf2(i2))
      end do
    end do
  end function f_spf_s_cc

end module omega_bispinor_colors
