! $Id: main4.f95,v 1.1 2004/04/09 20:11:17 ohl Exp $

program main4
  use omega_kinds
  use tao_random_numbers
  use testbed
  use rambo
  use omega_amplitudes4

  real(kind=single) :: roots
  integer :: n, tolerance
  character (len=8) :: mode

  call setup_parameters ()
  call read_parameters (roots, n, tolerance, mode)

  call check_omega ("A A -> F F", n, oaa_ff, oaa_ff, &
       real (roots, kind=omega_prec), &
       (/ 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec /), & 
       symmetry = reshape ((/ -1, 3, 4, 1, 1, 2 /), (/ 3, 2/)), &  
       states = (/ 1, 1, 2, 2 /), tolerance = tolerance, mode = mode) 

  call check_omega ("F F -> A A", n, off_aa, off_aa, &
       real (roots, kind=omega_prec), &
       (/ 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec /), & 
       symmetry = reshape ((/ 1, 3, 4, -1, 1, 2 /), (/ 3, 2/)), &  
       states = (/ 2, 2, 1, 1 /), tolerance = tolerance, mode = mode) 

  call check_omega ("F A -> F A", n, ofa_fa, ofa_fa, &
       real (roots, kind=omega_prec), &
       (/ 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec/), &
       symmetry = reshape ((/ 1, 1, 3 /), (/3, 1/)), &
       states = (/ 2, 1, 2, 1 /), tolerance = tolerance, mode = mode)   

  call check_omega ("F F -> F F", n, off_ff, off_ff, &
       real (roots, kind=omega_prec), &
       (/ 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec, 0.0_omega_prec /), &
       symmetry = reshape ((/ -1, 1, 2, -1, 3, 4/), (/3, 2/)), &
       states = (/ 2, 2, 2, 2 /), tolerance = tolerance, mode = mode)

end program main4


